var x y;
varexo v;

parameters r;

r = .975;

model;
  y = x;
  x = r*x(-1) + v;
end;

shocks;
  var v; stderr sqrt(0.02);
end;

steady;

check;

estimated_params;
  r,  .975, uniform_pdf,,,0,1;
  stderr y, sqrt(.2), uniform_pdf,,,0,1;
  stderr v, sqrt(.02), uniform_pdf,,,0,1;
end;

varobs y;


options_.particle.status = 1; // Required because we intend to use a nonlinear filter with a linear model

    estimation(nobs=100,
           mode_compute=0,
           mh_replic=0,
           cova_compute=0,
           mode_file=noisy,
           datafile=noisy_ar1_data,
           order=1,
           number_of_particles = 50000000,
           filter_algorithm=apf);


load optimal_value_with_linear_kalman_filter

diff = 100*abs((oo_.likelihood_at_initial_parameters-(-ovalue))/(-ovalue));

if diff>0.05
    error('Difference between NLKF and linear Kalman filter is bigger than 0.05%% (%.2f%%)', diff)
end
